function LocalDataSource(config) {
	// Debug flag
	var debug = 0;
	
	// Set the configuration fields
	var $scope 		= config.scope;
	var controller 	= $scope.controllerName;

	// Set the logging fields
	var $init 		= angular.injector(['ng']);
	var $log 		= $init.get('$log');
	
	// Initialize a local variable to hold current reference
	var self 		= this;

	/** 
	 * Load the local configuration and then connect 
	 */
	this.init = function() {
	};
	
	/** 
	 * Executes the local datasource as a snapshot 
	 */
	var snapshot = function(local, onSuccess, onError) {
		local.status = 'COMPLETE';
		
		for(var idx = 0; idx < local.dataset.length; idx++)
			$scope[local.dataset[idx]].setSchema(local.fields);
		for(var idx = 0; idx < local.dataset.length; idx++)
			$scope[local.dataset[idx]].operation('onSnapshotStart');
		
		// Loop over the data and send event for each
		for(var idx = 0; idx < local.data.length; idx++) {
			var d = local.data[idx];
			for(var dsIndex = 0; dsIndex < local.dataset.length; dsIndex++) {
				$scope[local.dataset[dsIndex]].operation('onInsert', d);
			}
		}					

		for(var idx = 0; idx < local.dataset.length; idx++)
			$scope[local.dataset[idx]].operation('onSnapshotEnd');
	};
	
	/** 
	 * Register a new local datasource on the system. 
	 */
	this.register = function(local, onSuccess, onError) {
		// Link to the datasets
		for(var idx = 0; idx < local.dataset.length; idx++) {			
			// Retrieve the dataset
			var datasetName = local.dataset[idx];
			var dataset = $scope[datasetName];
			
			// If dataset is not found, create it
			if(dataset == undefined) {
				dataset = new Dataset($scope, datasetName, local.primaryKey);
				$scope[datasetName] = dataset;
				$scope.$apply();
			}
			
			// OnReload function for the data source
			var onreload = function(onSuccess, onError) {
				snapshot(local, onSuccess, onError);
			};
			
			// Create the datasource and set the schema
			var datasource = new DataSource(local.name, 'Local', false, local, this, onreload);
			datasource.setSchema(local.fields);
			
			// Register the data source with the dataset
			dataset.registerSource(datasource);
		}

		snapshot(local, onSuccess, onError);
	};
}