app.controller('MainCtrl', function($scope, $log){	
	$scope.controllerName = 'MainCtrl';		
	
	$scope.setWell = function(well) {
		$scope.well = well;
	};
});


app.controller('NavigationCtrl', function($scope, $log){	
	$scope.controllerName = 'NavigationCtrl';
	var configurl = 'config/main-data.json';

	// Create an LDM data source and initialize
	$scope.ldmSource = new LDMDataSource({
		scope:		$scope,
		configurl: 	configurl
	});
	$scope.ldmSource.init();
	$scope.wells = [];
	
	var watch = $scope.$watch('WellListDS', function() {
		if($scope.WellListDS == undefined) return;
		watch();
		$scope.WellListDS.registerSink({
			onSchemaChange: function() {
			},
			onSnapshotStart: function() {
			},
			onSnapshotEnd: function() {
			},
			onInsert: function(object) {
				$scope.wells.push(object);
				$scope.$apply();
			},
			onUpdate: function() {
			},
			onDelete: function() {
			},
			onClear: function() {
			}
		});
	});
	
	$scope.showWellList = function() {
		$('#well-list').show();
	};
	
	$scope.hideWellList = function() {
		$('#well-list').hide();
	}
	
	$scope.switchWell = function(well) {
		$scope.$parent.setWell(well);
		$scope.hideWellList();
	}	
});

app.controller('DrillingCtrl', function($scope, $log){	
	$scope.controllerName = 'DrillingCtrl';
	var configurl = 'config/drilling-data.json';

	// Create an LDM data source and initialize
	$scope.ldmSource = new LDMDataSource({
		scope:		$scope,
		configurl: 	configurl
	});
	$scope.ldmSource.init();

	var watchMaster = $scope.$watch('DrillingDataDS', function() {
		if($scope.DrillingDataDS == undefined) return;
		watchMaster();
		$scope.$watch('$parent.well', function() {
			setTimeout(function() {
				$scope.ldmSource.applyParameters({'@WellName': $scope.$parent.well.WellName}, 'HoleDepthTime');
				$scope.ldmSource.applyParameters({'@WellName': $scope.$parent.well.WellName}, 'OperationCount');
				$scope.ldmSource.applyParameters({'@WellName': $scope.$parent.well.WellName}, 'Indicators');
				$scope.ldmSource.applyParameters({'@WellName': $scope.$parent.well.WellName}, 'CurrentData');
			},1000);
		});		
	});

	var watchCurrent = $scope.$watch('CurrentDataDS', function() {
		if($scope.CurrentDataDS == undefined) return;
		watchCurrent();
		$scope.CurrentDataDS.registerSink({
			onSchemaChange: function() {
			},
			onSnapshotStart: function() {
			},
			onSnapshotEnd: function() {
			},
			onInsert: function(object) {
				$scope.actual = object;
				$scope.$apply();
			},
			onUpdate: function() {
			},
			onDelete: function() {
			},
			onClear: function() {
				$scope.actual = null;
				$scope.$apply();
			}
		});
	});
	
	$scope.roundToFixed = function(val, dec) {
		if(val == undefined) return;
		if(val.isNaN) return;
		return val.toFixed(dec);
	};
});

app.controller('SurveyCtrl', function($scope, $log){	
	$scope.controllerName = 'SurveyCtrl';
	var configurl = 'config/survey-data.json';

	// Create an LDM data source and initialize
	$scope.ldmSource = new LDMDataSource({
		scope:		$scope,
		configurl: 	configurl
	});
	$scope.ldmSource.init();	

	var watchMaster = $scope.$watch('SurveyCoordinatesDS', function() {
		if($scope.SurveyCoordinatesDS == undefined) return;
		watchMaster();
		$scope.$watch('$parent.well', function() {
			setTimeout(function() {
				$scope.ldmSource.applyParameters({'@WellName': $scope.$parent.well.WellName}, 'SurveyCoordinates');
			},1000);
		});		
	});
	
	$scope.roundToFixed = function(val, dec) {
		if(val == undefined) return;
		if(val.isNaN) return;
		return val.toFixed(dec);
	};
});

