// This function adds show/hide handlers on div elements
(function ($) {
	$.each(['show', 'hide'], function (i, ev) {
		var el = $.fn[ev];
		$.fn[ev] = function () {
			this.trigger(ev);
			return el.apply(this, arguments);
		};
	});
})(jQuery);


// Hide any context menu when clicking anywhere on the document
angular.element(document).ready(function() {
	$(document).on("click", function(e){
		$('.context-menu').hide();
	});
});				


// Context menu directive
app.directive('ngContextMenu', function($log, $parse) {
    return function(scope, element, attrs) {
        var fn = $parse(attrs.ngContextMenu);
        element.bind('contextmenu', function(event) {
            scope.$apply(function() {
                event.preventDefault();
                //fn(scope, {$event:event});
            });
        });
    };
});


// Enter directive
app.directive('ngEnter', function ($log) {
	return function (scope, element, attrs) {
		element.bind("keydown keypress", function (event) {
			if(event.which === 13) {
				scope.$apply(function (){
					scope.$eval(attrs.ngEnter);
				});
				event.preventDefault();
			}
		});
	};
});


// For SVG and HTML element attributes to avoid late binding error in Javascript console
angular.forEach(['src', 'x', 'y', 'r', 'width', 'height', 'transform', 'stroke', 'fill'], function(name) {
  var ngName = 'ng' + name[0].toUpperCase() + name.slice(1);
  app.directive(ngName, function() {
    return function(scope, element, attrs) {
      attrs.$observe(ngName, function(value) {
        attrs.$set(name, value); 
      })
    };
  });
});