app.filter('orderByProperty', function($log) {
	return function(items, property, direction) {
		var filtered = [];
		angular.forEach(items, function(item) {
			filtered.push(item);
		});

		var compare = function(a, b, dir, field) {
			return dir * (a[field] == b[field] ? 0 : a[field] < b[field] ? 1 : -1);
		};
			
		filtered.sort(function (a, b) {
			var dir = direction == 'desc' ? 1 : -1;
			return compare(a, b, dir, property);
		});
		return filtered;
	};
});

app.filter('orderByPropertyInt', function($log) {
	return function(items, property, direction) {
		var filtered = [];
		angular.forEach(items, function(item) {
			filtered.push(item);
		});

		var compare = function(a, b, dir, field) {
			return dir * (parseInt(a[field]) == parseInt(b[field]) ? 0 : parseInt(a[field]) < parseInt(b[field]) ? 1 : -1);
		};
			
		filtered.sort(function (a, b) {
			var dir = direction == 'desc' ? 1 : -1;
			return compare(a, b, dir, property);
		});
		return filtered;
	};
});

app.filter('orderByFunction', function($log) {
	return function(items, functionName, direction) {
		var filtered = [];
		angular.forEach(items, function(item) {
			filtered.push(item);
		});

		var compare = function(a, b, dir, functionName) {
			return dir * (a[functionName]() == b[functionName]() ? 0 : a[functionName]() < b[functionName]() ? 1 : -1);
		};
			
		filtered.sort(function (a, b) {
			var dir = direction == 'desc' ? 1 : -1;
			return compare(a, b, dir, functionName);
		});
		return filtered;
	};
});


