package com.streambase.mqtt.broker;

import java.beans.IntrospectionException;

import com.streambase.mqtt.broker.MoquetteMQTTBroker.PayloadType;
import com.streambase.sb.operator.parameter.*;

public class MoquetteMQTTBrokerBeanInfo extends SBSimpleBeanInfo {
	public final static String START_ON_STARTUP_PROPERTY = "startOnStartup";
	public final static String START_ON_STARTUP_DISPLAY_NAME = "Start On Startup";
	public final static String START_ON_STARTUP_DESCRIPTION = "If enabled the MQTT broker server will startup on system startup";

	public final static String PAYLOAD_TYPE_PROPERTY = "payloadType";
	public final static String PAYLOAD_TYPE_DISPLAY_NAME = "Payload Type";
	public final static String PAYLOAD_TYPE_DESCRIPTION = "The type of payload to output";
	
	public final static String HOST_PROPERTY = "host";
	public final static String HOST_DISPLAY_NAME = "Host";
	public final static String HOST_DESCRIPTION = "The host the server will listen on";
	
	public final static String PORT_PROPERTY = "port";
	public final static String PORT_DISPLAY_NAME = "Port";
	public final static String PORT_DESCRIPTION = "The port the server will listen on";
	
	public SBPropertyDescriptor[] getPropertyDescriptorsChecked() throws IntrospectionException {
		return new SBPropertyDescriptor[] {
				new SBPropertyDescriptor(START_ON_STARTUP_PROPERTY, MoquetteMQTTBroker.class).displayName(START_ON_STARTUP_DISPLAY_NAME).description(START_ON_STARTUP_DESCRIPTION).optional(),
				new JavaEnumPropertyDescriptor<PayloadType>(PAYLOAD_TYPE_PROPERTY, MoquetteMQTTBroker.class, PayloadType.class).displayName(PAYLOAD_TYPE_DISPLAY_NAME).description(PAYLOAD_TYPE_DESCRIPTION).optional(),        
				new SBPropertyDescriptor(HOST_PROPERTY, MoquetteMQTTBroker.class).displayName(HOST_DISPLAY_NAME).description(HOST_DESCRIPTION).optional(),
				new SBPropertyDescriptor(PORT_PROPERTY, MoquetteMQTTBroker.class).displayName(PORT_DISPLAY_NAME).description(PORT_DESCRIPTION).optional()
		};
	}
}
