package com.streambase.accelerator.datasource.witsml;

import com.streambase.sb.CompleteDataType;
import com.streambase.sb.Tuple;
import com.streambase.sb.client.CustomFunctionResolver;


public class SchemaUtil {
	
	@SuppressWarnings("deprecation")
	@CustomFunctionResolver("SchemaToStringCustomFunctionResolver")
	public static byte[] SchemaToString(Tuple tuple) {
		if (tuple == null) {
			return new byte[0];
		}
		return tuple.getSchema().toSsqlStyleString().getBytes();
	}
	
	public static CompleteDataType SchemaToStringCustomFunctionResolver(CompleteDataType tuple) {
		return CompleteDataType.forString();
	}
	
	@CustomFunctionResolver("FilterNameCustomFunctionResolver")
	public static byte[] FilterName(String tableName) {
		if (tableName == null || tableName.length() == 0) {
			return new byte[0];
		}
		tableName = tableName.replaceAll("\\s|-", "_").replaceAll("[^a-zA-Z0-9_]", "");
		
		if (!tableName.matches("^[a-zA-Z].*")) {
			tableName = "A" + tableName;
		}
		
		return tableName.getBytes();
	}
	
	public static CompleteDataType FilterNameCustomFunctionResolver(CompleteDataType tuple) {
		return CompleteDataType.forString();
	}
}
