package com.streambase.accelerator.drilling.datasource.witsml;

import org.junit.Assert;
import org.junit.Test;

import com.streambase.accelerator.datasource.witsml.SchemaUtil;
import com.streambase.sb.CompleteDataType;
import com.streambase.sb.Schema;


public class TestSchemaUtils {

	@Test
	public void testSchemaToString() {
		String schemaString = new String(SchemaUtil.SchemaToString(new Schema("", new Schema.Field("Test", CompleteDataType.forString()), new Schema.Field("Test2", CompleteDataType.forInt())).createTuple()));
		Assert.assertEquals("(Test string, Test2 int)", schemaString);		
	}

	@Test
	public void testFitlerName() {
		String result = new String(SchemaUtil.FilterName(""));
		Assert.assertEquals("", result);
		
		result = new String(SchemaUtil.FilterName(null));
		Assert.assertEquals("", result);
		
		result = new String(SchemaUtil.FilterName("Test_Table_Name"));
		Assert.assertEquals("Test_Table_Name", result);
		
		result = new String(SchemaUtil.FilterName("Test#@_Table_.Name-Test"));
		Assert.assertEquals("Test_Table_Name_Test", result);
		
		result = new String(SchemaUtil.FilterName("Test#@_Table  _.Name"));
		Assert.assertEquals("Test_Table___Name", result);
		
		result = new String(SchemaUtil.FilterName("1Test#@_Table  _.Name"));
		Assert.assertEquals("A1Test_Table___Name", result);
		
		result = new String(SchemaUtil.FilterName("GTEM(TEMP)"));
		Assert.assertEquals("GTEMTEMP", result);
	}	
}
